
/*
 * File Z3MainLoop.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J8. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J8 only because so is required by the CASC-J8
 * rules, and for no other reason.
 */


#ifndef __Z3MainLoop__
#define __Z3MainLoop__

#if VZ3

#include "Forwards.hpp"

#include "Lib/Allocator.hpp"

#include "Kernel/MainLoop.hpp"
#include "Kernel/Problem.hpp"

#include "SAT/Z3Interfacing.hpp"

#include "Shell/Options.hpp"
#include "Shell/Statistics.hpp"

namespace SAT{

using namespace Kernel;
using namespace Shell;
using namespace Lib;

class Z3MainLoop : public MainLoop 
{
public:
  CLASS_NAME(Z3MainLoop);
  USE_ALLOCATOR(Z3MainLoop);  
  
  Z3MainLoop(Problem& prb, const Options& opt);
  ~Z3MainLoop(){};

protected:
  virtual void init();
  virtual MainLoopResult runImpl();


};

} 

#endif 
#endif 
